// CButtons.cp -- window methods
// Created 7/2/97 3:56 PM by AppMaker

#include "CButtons.h"

#include <UReanimator.h>
#include <URegistrar.h>
#include <LStream.h>
#include <CInvisibleButton.h>
#include <LStdControl.h>
#include <LGAPushButton.h>
#include <LButton.h>
#include <LGARadioButton.h>
#include <LToggleButton.h>
#include <LGACheckbox.h>
#include "CGadgetsData.h"
#include "DDocData.h"
#include "DAboutDialogData.h"
#include "GadgetsCmds.h"

#define PPob_ButtonsID	201
#define RidL_ButtonsID	201

Boolean		CButtons::sIsRegistered = false;

//----------
CButtons*
CButtons::CreateButtons(
	LCommander*			inSuperCommander,
	CGadgetsData*		inData)
{
	if (!sIsRegistered) {
		RegisterClass ();
	}

	CButtons*		window;
	window = (CButtons *)LWindow::CreateWindow(PPob_ButtonsID, inSuperCommander);
	window->ConnectToData (inData);
	return window;
}

//----------
void
CButtons::RegisterClass ()
{
	RegisterClass_(CButtons);

	// register the pane classes we use
	RegisterClass_(LCaption);
	RegisterClass_(CInvisibleButton);
	RegisterClass_(LStdButton);
	RegisterClass_(LGAPushButton);
	RegisterClass_(LButton);
	RegisterClass_(LStdCheckBox);
	RegisterClass_(LGARadioButton);
	RegisterClass_(LToggleButton);
	RegisterClass_(LGACheckbox);

	sIsRegistered = true;
}

//----------
CButtons::CButtons (
	LStream*	inStream)
	: LWindow (inStream)
{
}

//----------
CButtons::~CButtons()
{
}

//----------
//	This member function gets called once the containment hierarchy that contains
//	this pane has been built. It gives us a chance to get data members for
//	interesting subviews, and to do other operations now that our subviews exist.
void
CButtons::FinishCreateSelf()
{
	mInvisible2Button = (CInvisibleButton*)FindPaneByID ('Inv2');
	mOKButton = (LStdButton*)FindPaneByID ('OK  ');
	mX3DButton = (LGAPushButton*)FindPaneByID ('X3D ');
	mPictButtonButton = (LButton*)FindPaneByID ('Picn');
	mTitledPictButton = (LStdButton*)FindPaneByID ('Titt');
	mCheckCheck = (LStdCheckBox*)FindPaneByID ('Chek');
	mX3DRadioRadio = (LGARadioButton*)FindPaneByID ('X3Do');
	mPictCheckCheck = (LToggleButton*)FindPaneByID ('Pick');
	mX3DCheckCheck = (LGACheckbox*)FindPaneByID ('X3Dk');

	UReanimator::LinkListenerToControls(this, this, RidL_ButtonsID);
		// the purpose is to "connect" self to whatever controls
		// that we want to "listen" to

	// any additional initialization for your window:
}

//----------
void
CButtons::ConnectToData (
	CGadgetsData*		inData)
{
	mData = inData;

}

//----------
void
CButtons::ListenToMessage(
	MessageT	inMessage,
	void*		ioParam)
{
	switch (inMessage) {

	default:
		  ; // do something
		break;
	}
}

//----------
Boolean
CButtons::ObeyCommand(
	CommandT	inCommand,
	void*		ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	//		Remember to add same cases to FindCommandStatus below
	//		to enable/disable the commands


	default:
			cmdHandled = LWindow::ObeyCommand(inCommand, ioParam);
		break;
	}

	return cmdHandled;
}

//----------
void
CButtons::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{
	outUsesMark = false;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle

	default:
			LWindow::FindCommandStatus(inCommand, outEnabled,
										outUsesMark, outMark, outName);
		break;
	}
}
